{% extends "base.html" %}
{% block title %}Self-test{% endblock %}
{% block content %}

{% if 'error' in controller_status %}
    <div class="alert alert-danger">
        {{controller_status['error']}}
    </div>
{% elif 'status' in controller_status %}
    <div class="alert alert-success">
        {{controller_status['status']}}
    </div>
{% endif %}


<h2>Board self-test summary</h2>
<ul>
    <li>Status: {{ status['status'] }}</li>
    <li>Completed: {{ status['completed'] }}</li>     
    <li>Incomplete: {{ status['failed'] }}</li>
    <li>Skipped: {{ status['skipped'] }}</li>
    <li>Total: {{ status['total'] }}</li>
{% if status['running'] %}
    <li>Current step: {{ status['current_model'] }}</li>
{% endif %}
{% if status['running'] or status['report_ready'] %}
    <li>Start time: {{ status['start_time'] }}</li>
    <li>End time: {{ status['end_time'] }}</li>
    <li>Time elapsed: {{ status['time_elapsed'] }}</li>
{% endif %}
{% if status['report_ready'] %}
    <li><a href="{{url_for('self_test_download_report')}}">Download full report</a></li>
{% endif %}
</ul>


<h3>Please select the tests to run</h3>
<form method="post" class="mb-4" role="form" action="{{url_for('self_test_start')}}" method="post">
    <table class="table table-striped">
        <thead>
            <tr>
                <td>&nbsp;</td>
                <td>Test description</td>
            </tr>            
        </thead>        

        {% for name, item in schedule.items() %}
            <tr>                
                <td>
                    <input id="{{name}}.test_enabled" name="{{name}}.test_enabled" type="checkbox" value="1" {{item["checked"]}} {% if status['running'] %}disabled{% endif %}>
                    <input name="{{name}}.test_enabled" type="hidden" value="0">
                </td>
                <td><label for="{{name}}.test_enabled">{{item["description"]}}</label></td>
            </tr>
        {% endfor %}
    </table>
    {% if status['running'] %}
        <button class="btn btn-danger" type="submit" formaction="{{url_for('self_test_stop')}}">Stop</button>    
    {% else %}
        <button class="btn btn-primary" type="submit" formaction="{{url_for('self_test_start')}}">Start</button>
        <button class="btn btn-primary" type="submit" formaction="{{url_for('configure_firefly')}}">Configure for eye scans</button>
    {% endif %}
</form>


<h3>Most recent test results 
{% if status['report_ready'] %}
    <a href="{{url_for('self_test_download_report')}}"><span class="badge rounded-pill bg-primary">Download</span></a>
{% endif %}
</h3>

<table class="table table-striped">
    <thead>
        <tr>
            <td>Test description</td>
            <td>Result</td>
        </tr>
    </thead>

    {% for name, item in summary.items() %}
    <tr>
        <td>{{item["description"]}}</td>
        <td class="text-{{item['class']}}">{{item["result"]}}</td>
    </tr>
    {% endfor %}
</table>

{% endblock %}